SystemOrganization addCategory: #Forum!
SystemOrganization addCategory: 'Forum-Announcements'!
SystemOrganization addCategory: 'Forum-Application'!
SystemOrganization addCategory: 'Forum-Browser'!
SystemOrganization addCategory: 'Forum-Model'!
SystemOrganization addCategory: 'Forum-Tests'!

QCParentObject subclass: #FOAuthor
	instanceVariableNames: 'userName password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOAuthor methodsFor: 'default values' stamp: 'DiegoLont 1/22/2014 13:23'!
curLanguage
	^nil! !

!FOAuthor methodsFor: 'accessing' stamp: 'DiegoLont 1/21/2014 15:04'!
newQuestion
	^self model newQuestion
		author: self;
		yourself! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:45'!
password
	^ password! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:45'!
password: anObject
	password := anObject! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 15:28'!
userName
	^ userName! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 15:27'!
userName: aUserName
	userName := aUserName! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 1/28/2013 16:05'!
username
	^ userName! !

TestCase subclass: #TestAnswer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

TestCase subclass: #TestAuthor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!TestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorCanAnswerQuestion
	|model author question answer|
	model := FOModel new.
	author := model newAuthor.
	question := author newQuestion.
	answer := question newAnswer: author.
	self assert: author equals: answer author.
	self assert: (question hasAnswer: answer)! !

!TestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorCanAskQuestion
	|model author question|
	model := FOModel new.
	author := model newAuthor.
	question := author newQuestion.
	self assert: author equals: question author.
	self assert: (model hasQuestion: question)! !

!TestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorHasUsername
	|author|
	author := FOAuthor new
		userName: 'Kent';
		yourself.
	self assert: 'Kent' equals: author userName! !

!TestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorKnowsModel
	|author model|
	model := FOModel new.
	author := model newAuthor.
	self assert: author model notNil.
	self deny: FOModel default = author model.
	self assert: model equals: author model! !

!TestAuthor methodsFor: 'tests' stamp: 'StephanEggermont 5/20/2011 23:53'!
testAuthorNamedKnowsModel
	|author model|
	model := FOModel new.
	author := model authorNamed: 'Martin'.
	self assert: author model notNil.
	self deny: FOModel default = author model.
	self assert: model equals: author model! !

TestCase subclass: #TestModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelCanFindAuthorsByName
	|model author| 
	model := FOModel new.
	author := model newAuthor
		userName: 'Joel';
		yourself.
	self assert: (model authorNamed: 'Joel') equals:author! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 10/3/2011 11:44'!
testModelCanFindAuthorsByNameAndPassword
	|model author| 
	model := FOModel new.
	author := model newAuthor
		userName: 'Joel';
		password: 'leoJ';
		yourself.
	self assert: (model authorNamed: 'Joel') equals:author! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testModelDoesntKnowOtherQuestions
	|model question| 
	model := FOModel new.
	question := FOQuestion new.
	self deny: (model hasQuestion: question).
! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsAuthors
	|model author| 
	model := FOModel new.
	author := model newAuthor.
	self assert: (model authors size = 1).
	self assert: (model authors includes: author)! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsQuestions
	|model question| 
	model := FOModel new.
	question := model newQuestion.
	self assert: (model hasQuestion: question).
	self assert: (model questions size = 1).! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsTags
	|model tag| 
	model := FOModel new.
	tag := model newTag.
	self assert: (model tags size = 1).
	self assert: (model tags includes: tag)! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testModelKnowsTheNumberOfQuestions
	|model question| 
	model := FOModel new.
	self assert: (model questions size = 0).
	question := model newQuestion.
	self assert: (model questions size = 1).
	question := model newQuestion.
	self assert: (model questions size = 2).
	question := model newQuestion.
	self assert: (model questions size = 3).! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 10/3/2011 12:00'!
testModelReturnsNewAuthorWhenRegistering
	|model author| 
	model := FOModel new.
	author := model registerAuthor: 'Joel' password: 'leoJ'.
	self assert: (model authors size = 1).
	self assert: (model authors includes: author)! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 10/3/2011 11:46'!
testModelReturnsNilIfPasswordWrong
	|model author| 
	model := FOModel new.
	author := model newAuthor
		userName: 'Joel';
		password: 'leoJ';
		yourself.
	self assert: (model authorNamed: 'Joel' password: 'leoJ') equals: author.
	self assert: (model authorNamed: 'Joel' password: 'leo') equals: nil.
	! !

!TestModel methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testTheSharedModelExists
	|model|
	model := FOModel default.
	self assert: (model questions size>= 0)! !

TestCase subclass: #TestPost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testAuthorCannotVoteOwnPost
	|post author|
	post := FOPost new.
	post author: author.
	post voteUp: author.
	self assert: 0 equals: post voteSize.
	post voteDown: author.
	self assert: 0 equals: post voteSize! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testPostHasContent
	|post|
	post := FOPost new
		content: 'Question, answer or comment?';
		yourself.
	self assert: 'Question, answer or comment?' equals: post content! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/20/2011 16:15'!
testPostShouldShowDefaultAuthorName
	|post |
	post := FOPost new.
	self assert: 'Anonymous' equals: post authorName
	! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/20/2011 16:17'!
testPostShouldShowRealAuthorName
	|post author|
	post := FOPost new.
	author := FOAuthor new
		userName: 'Willem';
		yourself.
	post author: author.
	self assert: 'Willem' equals: post authorName
	! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testPostStartsWithZeroVotes
	|post|
	post := FOPost new.
	self assert: 0 equals: post voteSize! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:09'!
testPostVoteSize
	|post author1 author2|
	post := FOAnswer new.
	author1 := FOAuthor new.
	author2 := FOAuthor new.
	self assert: 0 equals: post voteSize.
	post voteUp: author1.
	self assert: 1 equals: post voteSize.
	post voteDown: author2.
	self assert: 2 equals: post voteSize.
	
! !

!TestPost methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:08'!
testPostVoteValue
	|post author1 author2|
	post := FOPost new.
	author1 := FOAuthor new.
	author2 := FOAuthor new.
	self assert: 0 equals: post voteValue.
	post voteUp: author1.
	self assert: 1 equals: post voteValue.
	post voteDown: author2.
	self assert:  0 equals: post voteValue.
	
! !

TestCase subclass: #TestQuestion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 4/3/2013 20:58'!
testNewQuestionIsNotAnswered
	| question |
	question := FOQuestion new.
	self deny: question isAnswered.! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testOneAnswerIsNotUnanswered
	|question answer |
	question := FOQuestion new.
	answer := question newAnswer.
	self assert: question isAnswered! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testOnlyOneAnswerCanBeAccepted
	|question answer answer2|
	question := FOQuestion new.
	answer := question newAnswer.
	answer2 := question newAnswer.
	self assert: (question canAccept: answer).
	self assert: (question canAccept: answer2).
	answer accept.
	self assert: question hasAcceptedAnswer.
	self deny: (question canAccept: answer2).! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionHasRightNumberOfAnswersString
	|question answer|
	question := FOQuestion new.
	self assert: '0 Answers' equals: question answerSizeString.
	answer := question newAnswer.
	self assert: '1 Answer' equals: question answerSizeString.
	answer := question newAnswer.
	self assert: '2 Answers' equals: question answerSizeString.! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 22:24'!
testQuestionHasTagString
	|question|
	question := FOQuestion new
		addTag: (FOTag new 
			description: 'one';
			yourself);
		addTag: (FOTag new
			description: 'two';
			yourself);
		yourself.
	self assert: 'one two' equals: question tagString ! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionHasTitle
	|question|
	question := FOQuestion new
		title: 'How does this work?';
		yourself.
	self assert: 'How does this work?' equals: question title ! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 4/3/2013 21:00'!
testQuestionIsAnswered
	| question answer |
	question := FOQuestion new.
	answer := question newAnswer.
	answer accept.
	self deny: question isAnswered.
	! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowsAnswers
	|question answer|
	question := FOQuestion new.
	answer := question newAnswer.
	self assert: (question hasAnswer: answer).
	answer := FOAnswer new.
	self deny: (question hasAnswer: answer)
! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowsComments
	|question comment|
	question := FOQuestion new.
	comment := question newComment.
	self assert: (question hasComment: comment).
	comment := FOComment new.
	self deny: (question hasComment: comment).
	! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowsNumberOfAnswers
	|question answer|
	question := FOQuestion new.
	self assert: 0 equals: question answerSize.
	answer := question newAnswer.
	self assert: 1 equals: question answerSize.! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionKnowstags
	|tag question|
	tag := FOTag new
		description: 'Smalltalk';
		yourself.		
	question := FOQuestion new
		addTag: tag;
		yourself.
	self assert: 1 equals: question tags size.
	self assert: (question hasTag: tag)
		! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionStartsUnaccepted
	|question|
	question := FOQuestion new.
	self deny: question hasAcceptedAnswer! !

!TestQuestion methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testQuestionStartsUnanswered
	|question|
	question := FOQuestion new.
	self deny: question isAnswered! !

TestCase subclass: #TestTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!TestTag methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testTagHasDescription
	|tag|
	tag := FOTag new
		description: 'Smalltalk';
		yourself.
	self assert: 'Smalltalk' equals: tag description! !

!TestTag methodsFor: 'tests' stamp: 'StephanEggermont 5/19/2011 16:10'!
testTagKnowsQuestions
	|tag question|
	tag := FOTag new
		description: 'Smalltalk';
		yourself.		
	self assert: 0 equals: tag questions size.
	question := FOQuestion new
		addTag: tag;
		yourself.
	self assert: 1 equals: tag questions size.
		! !

QCSession subclass: #FOSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

QCPageChoice subclass: #FOAgileOverflow
	instanceVariableNames: 'loginName password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAgileOverflow class methodsFor: 'class initialization' stamp: 'DiegoLont 1/22/2014 14:41'!
initialize
	"Registers this application as webpage
		FOAgileOverflow initialize.
	"
	(WAAdmin register: self asApplicationAt: 'AgileOverflow')
		preferenceAt: #sessionClass
			put: FOSession;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator;
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: TBSDevelopmentLibrary;
		addLibrary: FOFileLibrary;
		yourself
! !

!FOAgileOverflow methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:04'!
askQuestion
	self announce: FOGoAskQuestion! !

!FOAgileOverflow methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:04'!
askQuestion2
	self announce: FOGoAskQuestion2! !

!FOAgileOverflow methodsFor: 'initialization' stamp: 'DiegoLont 1/22/2014 13:04'!
initialize 
	super initialize.
	self addPage: FOHome new announcement: FOGoHome.
	self addPage: FOAskQuestionSeaside new announcement: FOGoAskQuestion.
	self addPage: FOAskQuestionMagritte new announcement: FOGoAskQuestion2.
	self addPage: FOAllQuestions new announcement: FOGoAllQuestions.
	self addPage: FOViewQuestion new announcement: FOGoViewQuestion symbol: #question.
! !

!FOAgileOverflow methodsFor: 'user management' stamp: 'StephanEggermont 10/3/2011 11:53'!
login
	self user: (FOModel default authorNamed: loginName password: password).! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 16:06'!
loginName
	^ loginName! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 16:06'!
loginName: anObject
	loginName := anObject! !

!FOAgileOverflow methodsFor: 'actions' stamp: 'StephanEggermont 4/3/2013 20:46'!
logout
	self user: nil.! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:42'!
password
	^ password! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:42'!
password: anObject
	password := anObject! !

!FOAgileOverflow methodsFor: 'user management' stamp: 'StephanEggermont 10/3/2011 12:03'!
register
	self user: (FOModel default registerAuthor: loginName password: password).! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'StephanEggermont 10/18/2010 11:29'!
renderBottomOn: canvas! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 16:54'!
renderContentOn: canvas
	self renderTopOn: canvas.
	canvas div
		class: 'main-wrapper';
		with: [ self
			renderHeaderOn: canvas;
			renderMainOn: canvas;
			renderBottomOn: canvas ]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 16:56'!
renderHeaderOn: canvas
	canvas tbsPageHeader: [ 
		canvas heading
			class: 'home';
			with: [
				canvas anchor 
					callback: [self goHome];
					with: 'AgileOverflow'] ]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 16:48'!
renderLoginOrRegisterOn: canvas
	canvas tbsFormGroup: [ 
		canvas label for: 'username'; class: 'sr-only'; with: 'User name'.
		canvas textInput tbsFormControl; id: 'username'; placeholder: 'Enter username'; on: #loginName of: self.
		canvas space].

	canvas tbsFormGroup: [ 
		canvas label for: 'password'; class: 'sr-only'; with: 'Password'.
		canvas passwordInput tbsFormControl id: 'password'; placeholder: 'Password'; on: #password of: self.
		canvas space]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 14:56'!
renderMainOn: canvas
	canvas div
		class: 'top';
		with: [self renderQuestionHeaderOn: canvas].
	canvas div 
		class: 'main';
		with: [canvas render: self currentPage]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 16:51'!
renderQuestionHeaderOn: canvas
	canvas tbsForm beInline; with: [
		self isLoggedIn ifFalse: [ self renderLoginOrRegisterOn: canvas ].
		canvas tbsButtonToolbar: [ 
			canvas tbsButtonGroup beSmall with: [ 
				self isLoggedIn
					ifTrue: [ 
						canvas tbsButton beDefault; on: #askQuestion of: self.
						canvas tbsButton beDefault; on: #askQuestion2 of: self ]
					ifFalse: [
						canvas tbsButton beDefault; on: #login of: self.
						canvas tbsButton beDefault; on: #register of: self ] ].
			canvas tbsButtonGroup beSmall with: [ 
				canvas tbsButton beDefault; on: #viewAllQuestions of: self ] ] ].
! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 17:04'!
renderTopMetaOn: canvas
	canvas tbsButtonToolbar with: [
		canvas tbsButtonGroup beExtraSmall
			with: [
				canvas tbsButton beDefault; with: 'chat'.
				canvas tbsButton beDefault; with: 'meta'.
				canvas tbsButton beDefault; with: 'about'.
				canvas tbsButton beDefault; with: 'faq' ] ]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 17:04'!
renderTopOn: canvas
	canvas tbsForm
		beInline;
		with: [
			canvas tbsFormGroup: [ self renderTopUserOn: canvas ].
			canvas tbsFormGroup: [ self renderTopMetaOn: canvas ].
			canvas tbsFormGroup: [ self renderTopSearchOn: canvas ] ]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 17:04'!
renderTopSearchOn: canvas
	canvas textInput on: #search of: self! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 17:03'!
renderTopUserOn: canvas
	canvas text: self username.
	self ifLoggedIn: [ canvas tbsButton beDefault; beExtraSmall; on: #logout of: self]! !

!FOAgileOverflow methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 16:24'!
search
	" todo: search "
	^'search'! !

!FOAgileOverflow methodsFor: 'accessing' stamp: 'DiegoLont 1/22/2014 14:55'!
search: aString
	^'search'! !

!FOAgileOverflow methodsFor: 'updating' stamp: 'StephanEggermont 5/19/2011 13:46'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'AgileOverflow'
! !

!FOAgileOverflow methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:04'!
viewAllQuestions
	self announce: FOGoAllQuestions! !

WAFileLibrary subclass: #FOFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOFileLibrary methodsFor: 'accessing' stamp: 'DiegoLont 1/22/2014 16:58'!
mainCss
	^'
	.topbar{
		width: 960px;
		background-color: #eeeeee;
		height: 50px;
		border: 0;
		margin: 0;
		padding: 0;
	}	
	.hlinks{
		float: right
	}
	.userspan{
		text-align: right;
		font-weight: bold;
		font-size: 12px;
		color: #0077CC;
		padding: 15px 20px 2px 0px;
	}
	body{
		font-family:Arial,Liberation Sans,DejaVu Sans,sans-serif;
		border: 0;
		margin: 0;
		padding: 0;
	
	}
	.home a {
		color: #111;
		text-decoration: none;
	}
	.main-wrapper { 
		padding: 0 0 0 20px;
	}
.question{
	float: left;
	border-bottom: 1px dotted #999;
	overflow: hidden;
	width: 730px;
	display: block;
}
.votes{
	display: block;
	float: left;
	width: 38px;
	padding: 5px;
	text-align: center;
}	
.votes a{
	text-decoration: none;
	color: #aaa;
}
.summary{
	float: left;
	width: 550px;
	margin: 5px;
}
.question .count{
	font-size: 190%;
}
.summary .title{
	font-size: 14px;
	height: 20px;
}
.summary a{
	text-decoration: none;
}
.summary .contents{
	height: 30px;
	overflow: hidden;
	font-size: 12px;
}
.summary .author{
	float: right;
	font-size: 12px;
	color: blue;
}
.view-answer {
	padding: 5px;
	border-bottom: 1px solid #aaa;
}
view-answer h2 {
	font-size: 16px;
}
answer-summary{
	float: left;
	width: 550px;
	margin: 5px;
}
.view-question h1{
	padding: 5px;
	font-size: 24px;
	border-bottom: 1px solid #aaa;
}
	'! !

!FOFileLibrary methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 13:45'!
selectorsToInclude
	^#(mainCss)! !

QCObject subclass: #FOPost
	instanceVariableNames: 'author votes content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOPost commentStamp: 'StephanEggermont 5/19/2011 11:10' prior: 0!
A F2Post has an author and can be voted on!

FOPost subclass: #FOAnswer
	instanceVariableNames: 'accepted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOAnswer class methodsFor: 'as yet unclassified' stamp: 'WillemvandenEnde 10/3/2011 14:37'!
editFields
	^self fields! !

!FOAnswer class methodsFor: 'as yet unclassified' stamp: 'WillemvandenEnde 10/3/2011 14:37'!
fields
	^#(contentsField)! !

!FOAnswer methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:08'!
accept
	accepted := true.! !

!FOAnswer methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:08'!
accepted
	^accepted ifNil: [^false]! !

FOPost subclass: #FOComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOPost class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 12:39'!
contentsField
	^DEMemoField new
		label: 'Contents';
		accessor: #(content);
		validator: (DEStringValidator new
			beRequired;
			errorMessage: 'Contents is verplicht';
			yourself);
		yourself! !

!FOPost class methodsFor: 'fields' stamp: 'StephanEggermont 5/21/2011 00:01'!
nrOfVotesField
	^DENumberField new
		label: '#votes';
		accessor: #(voteSize);
		beReadonly;
		yourself! !

!FOPost class methodsFor: 'fields' stamp: 'StephanEggermont 5/21/2011 00:03'!
votesField
	^DENumberField new
		label: 'vote';
		accessor: #(voteValue);
		beReadonly;
		yourself! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:08'!
author
	^author! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:09'!
author: anAuthor
	author := anAuthor! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 16:17'!
authorName
	author ifNil: [^'Anonymous'].
	^ author userName! !

!FOPost methodsFor: 'testing' stamp: 'DiegoLont 1/22/2014 11:20'!
canRemove
	^false! !

!FOPost methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 11:06'!
containerDefaults: aContainer
	<magritteContainer>
	^aContainer
		! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:38'!
content
	^content! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:38'!
content: aContent
	content := aContent! !

!FOPost methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 10:41'!
descriptionContents
	<magritteDescription>
	^MAMemoDescription new
		label: 'Contents';
		accessor: #content;
		beRequired;
		requiredErrorMessage: 'Contents needs to be filled out.';
		yourself! !

!FOPost methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 10:41'!
descriptionNumberOfVotes
	<magritteDescription>
	^MANumberDescription new
		label: '#votes';
		accessor: #voteSize;
		beReadonly;
		priority: 200;
		yourself! !

!FOPost methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 10:41'!
descriptionVotes
	<magritteDescription>
	^MANumberDescription new
		label: 'vote';
		accessor: #voteValue;
		beReadonly;
		priority: 100;
		yourself! !

!FOPost methodsFor: 'initialization' stamp: 'DiegoLont 1/22/2014 13:15'!
initialize
	super initialize.
	author := self user! !

!FOPost methodsFor: 'accessing' stamp: 'DiegoLont 8/4/2011 09:59'!
voteDown: anAuthor
	author ~= anAuthor ifTrue: [
		self votes add: (FOVote down: anAuthor)]! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:09'!
voteSize
	^self votes size! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:10'!
voteUp: anAuthor
	author ~= anAuthor ifTrue: [
		self votes add: (FOVote up: anAuthor)]! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:23'!
voteValue
	^self votes inject: 0 into: [:sum :each | sum+ each increment]! !

!FOPost methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:09'!
votes
	^votes ifNil: [votes := OrderedCollection new]! !

FOPost subclass: #FOQuestion
	instanceVariableNames: 'answers title tags comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOQuestion class methodsFor: 'fields' stamp: 'StephanEggermont 5/19/2011 16:19'!
editFields
	^self fields! !

!FOQuestion class methodsFor: 'fields' stamp: 'StephanEggermont 5/19/2011 22:00'!
fields
	^#(titleField contentsField)! !

!FOQuestion class methodsFor: 'fields' stamp: 'StephanEggermont 5/21/2011 00:04'!
reportFields
	^#(titleField contentsField nrOfVotesField votesField)! !

!FOQuestion class methodsFor: 'fields' stamp: 'DiegoLont 8/21/2011 12:39'!
titleField
	^DEStringField new
		label: 'Title';
		accessor: #(title);
		validator: (DEStringValidator new
			beRequired;
			errorMessage: 'Een title is verplicht';
			yourself);
		yourself! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 12:00'!
addTag: aTag
	aTag questions add: self.
	self tags add: aTag! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:40'!
answerSize
	^self answers size! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:43'!
answerSizeString
	self answers size = 1 ifTrue: [^'1 Answer'].
	^self answers size asString,' Answers'! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:10'!
answers
	^answers ifNil: [answers := OrderedCollection new]! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 16:27'!
canAccept: anAnswer
	^self hasAcceptedAnswer not and: [self answers includes: anAnswer]! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 12:11'!
comments
	^comments ifNil: [comments := OrderedCollection new]! !

!FOQuestion methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 10:43'!
descriptionTitle
	<magritteDescription>
	^MAStringDescription new
		label: 'Title';
		accessor: #title;
		beRequired;
		requiredErrorMessage:'A title is required.';
		yourself! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 16:12'!
hasAcceptedAnswer
	^self answers anySatisfy: [:each |each accepted]! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/19/2011 12:09'!
hasAnswer: anAnswer
	^self answers includes: anAnswer! !

!FOQuestion methodsFor: 'testing' stamp: 'WillemvandenEnde 10/3/2011 14:13'!
hasAnswers
	 ^answers notNil.! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/19/2011 12:10'!
hasComment: aComment
	^self comments includes: aComment! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/19/2011 11:59'!
hasTag: aTag
	^self tags includes: aTag! !

!FOQuestion methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 16:19'!
isAnswered
	^self answers size > 0! !

!FOQuestion methodsFor: 'adding' stamp: 'StephanEggermont 5/19/2011 16:09'!
newAnswer
	|answer|
	answer := FOAnswer new.
	self answers add: answer.
	^answer! !

!FOQuestion methodsFor: 'adding' stamp: 'StephanEggermont 5/19/2011 16:09'!
newAnswer: anAuthor
	^self answers add: (FOAnswer new
		author: anAuthor;
		yourself).
! !

!FOQuestion methodsFor: 'adding' stamp: 'StephanEggermont 5/19/2011 16:09'!
newComment
	^self comments add: FOComment new.
! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 22:22'!
tagString
	^String streamContents: [:s |
		self tags do: [:tag |
			s nextPutAll: tag description] separatedBy: [s space]]! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:59'!
tags
	^tags ifNil: [tags := OrderedCollection new]! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:32'!
title
	^title! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 15:44'!
title: aTitle
	title := aTitle.
! !

Announcement subclass: #FOGoAllQuestions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoAskQuestion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoAskQuestion2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

Announcement subclass: #FOGoViewQuestion
	instanceVariableNames: 'question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

!FOGoViewQuestion class methodsFor: 'instance creation' stamp: 'StephanEggermont 4/28/2011 22:40'!
on: aQuestion
	^self new
		question: aQuestion;
		yourself! !

!FOGoViewQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:35'!
question
	^ question! !

!FOGoViewQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:35'!
question: anObject
	question := anObject! !

Object subclass: #FOBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Browser'!

!FOBrowser class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/3/2013 15:13'!
open
	^self new browser openOn: self! !

!FOBrowser methodsFor: 'browsers' stamp: 'StephanEggermont 4/3/2013 15:48'!
browser
	|browser|
	browser := GLMTabulator new.
	browser 
		title: 'Forum Code Quality';
		row: #details.
	browser transmit to: #details; andShow: [ :a |
		self complexityOn: a.
		self complexity2On: a.
		self uncategorizedOn: a.
		self distibutionMapOn: a].
	^browser.
! !

!FOBrowser methodsFor: 'browsers' stamp: 'StephanEggermont 1/23/2014 15:58'!
complexity2On: a
	a roassal
		title: 'Package Complexity';
		painting: [:view|
			| packages  allClasses|
			packages := (RPackageOrganizer default packages select: [ :p | 
				p packageName beginsWith: 'Forum' ]) first packages.
			allClasses := IdentitySet new.
			packages do: [ :p | allClasses addAll: p classes ].				
			view interaction action: #browse.
			view shape rectangle.
			view nodes: packages forEach: [ :aPackage |
				view interaction action: #browse.
				view shape rectangle 
				width: [:cls | cls instVarNames size * 6];
				height: [:cls | cls methods size*2];
				fillColor: (RONColorLinearNormalizer 
					inContext: allClasses 
					withCommand: [:cls |
						cls methods inject: 0 into: [:sum :el | sum + el getSource lineCount]]
					lowColor: Color green 
					highColor: Color red).
			view nodes: aPackage classes.
			view treeLayout].
			view edges: allClasses from: #superclass to: #yourself.				
		view gridLayout]
! !

!FOBrowser methodsFor: 'browsers' stamp: 'DiegoLont 1/21/2014 14:51'!
complexityOn: a
	a roassal
		title: 'Complexity';
		painting: [:view|
"Each node is a class, edges designate inheritance.
Height is linear to the number of method the class defines.
Width is linear to the number of variables the class defines.
Color color is linear to the number of lines of code of the class.
The darkest node designates the class that has the highest number of lines of code"
			| packages classes |
			packages := PackageInfo allPackages select: [ :p | self mondrianPackage: p ].
			classes := OrderedCollection new.
			packages do: [ :p | classes addAll: p classes ].				
			view interaction action: #browse.
			view shape rectangle
				width: [:cls | cls instVarNames size * 6];
				height: [:cls | cls methods size * 2 ];
				linearFillColor: [:cls | cls methods inject: 0 into: [:sum :el | sum + el getSource lineCount]] within: classes.
			view nodes: classes.
			view edgesFrom: #superclass.				
			view treeLayout].
! !

!FOBrowser methodsFor: 'browsers' stamp: 'DiegoLont 1/21/2014 14:52'!
distibutionMapOn: a
		a roassal 
			title: 'Distribution map';
			painting: [:view |
		"Simple example of a distribution map. 
		Green methods are short. Orange are long. Red are very long"
			| classes d packages  |
			packages := PackageInfo allPackages select: [ :p | self mondrianPackage: p ].
			classes := OrderedCollection new.
			packages do: [ :p | classes addAll: p classes ].				
			d := IdentityDictionary new.
			classes do: [:aClass | aClass methods do: [:m | d at: m put: m getSource lineCount ] ].

			view shape rectangle withoutBorder.
			view nodes: classes forEach: [ :each |
				view shape label.
				view node: each.
				view node: each forIt: [
					view shape rectangle size: 12;
						if: [:m | (d at: m) < 5 ] fillColor: Color green;
						if: [:m | (d at: m) >= 5 and: [ (d at: m) < 25 ] ] fillColor: Color orange;
						if: [:m | (d at: m) >= 25 ] fillColor: Color red.
					view nodes: (each methods sortedAs: [:m | (d at: m) ]).
					view gridLayout gapSize: 2 ].
					view verticalLineLayout ].
	
			view gridLayout]
! !

!FOBrowser methodsFor: 'browsers' stamp: 'StephanEggermont 4/3/2013 15:12'!
mondrianPackage: aPackage
	(aPackage packageName beginsWith: 'Forum') ifTrue: [ ^true ].
	^false.! !

!FOBrowser methodsFor: 'browsers' stamp: 'DiegoLont 1/21/2014 14:51'!
uncategorizedOn: a
	a roassal 
		title: 'Uncategorized methods';
		painting: [:view |
"This visualization is useful to track down 'as yet unclassified' method categories. This is widely recognized as a bad Smalltalk practice to have such a method category" 

			| packages classes |
			packages := PackageInfo allPackages select: [ :p | self mondrianPackage: p ].
			classes := OrderedCollection new.
			packages do: [ :p | classes addAll: p classes ].

			view shape rectangle 
				size: 20;
			if: [ :cls | cls organization categories includesAnyOf: #(#'as yet unclassified ' #'as yet unclassified') ] fillColor: Color red.
	
			view interaction action: #browse.
			view nodes: classes.
			view edgesFrom: #superclass.
			view treeLayout].
! !

Object subclass: #FOModel
	instanceVariableNames: 'questions authors tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

FOModel class
	instanceVariableNames: 'default'!

FOModel class
	instanceVariableNames: 'default'!

!FOModel class methodsFor: 'singleton' stamp: 'StephanEggermont 5/18/2011 16:04'!
default
	^default ifNil: [default := self new]! !

!FOModel class methodsFor: 'singleton' stamp: 'StephanEggermont 5/19/2011 16:14'!
reset
	default := nil! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 23:55'!
authorNamed: aName
	|retVal|
	retVal := self authors detect: [:each | each userName = aName] ifNone: [ 	
		|author|
		author := (FOAuthor on: self)
			userName: aName;
			yourself.
		self authors add: author.
		retVal :=author].
	^retVal.! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 11:48'!
authorNamed: aName password: aPassword
	^self authors detect: [:each |
		 (each userName = aName) and: [each password = aPassword]]
	 ifNone: [ ^nil].
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 16:45'!
authors
	^authors ifNil: [authors := OrderedCollection new]! !

!FOModel methodsFor: 'magritte-description' stamp: 'DiegoLont 1/22/2014 10:53'!
descriptionAllQuestions
	<magritteDescription>
	^MAToManyRelationDescription new
		label: 'All questions';
		accessor: #questions;
		classes: (Array with: FOQuestion);
		yourself! !

!FOModel methodsFor: '*forum-application' stamp: 'DiegoLont 1/22/2014 11:19'!
descriptionAllQuestions: aDescription
	<magritteDescription: #descriptionAllQuestions>
	" sets the defaults for rendering this description "
	^aDescription
		componentClass: QCToManyComponent;
		yourself! !

!FOModel methodsFor: 'testing' stamp: 'StephanEggermont 5/18/2011 15:53'!
hasQuestion: aQuestion
	^self questions includes: aQuestion! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:08'!
newAuthor
	^self authors add: (FOAuthor on: self)
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:10'!
newQuestion
	^self questions add: FOQuestion new
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 16:10'!
newTag
	^self tags add: FOTag new
! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/18/2011 15:16'!
questions
	^questions ifNil: [questions := OrderedCollection new]! !

!FOModel methodsFor: 'accessing' stamp: 'DiegoLont 1/22/2014 10:59'!
questions: aCollection 
	questions := aCollection! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 10/3/2011 12:01'!
registerAuthor: aName password: aPassword
	|retVal|
	retVal := self authors detect: [:each | each userName = aName] ifNone: [ 	
		|author|
		author := (FOAuthor on: self)
			userName: aName;
			password: aPassword;
			yourself.
		self authors add: author.
		retVal :=author].
	^retVal.! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:48'!
tags
	^tags ifNil: [tags := OrderedCollection new]! !

Object subclass: #FOTag
	instanceVariableNames: 'description questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOTag methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:53'!
description
	^description! !

!FOTag methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:53'!
description: aDescription
	description := aDescription! !

!FOTag methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 11:55'!
questions
	^questions ifNil: [questions := OrderedCollection new]! !

Object subclass: #FOVote
	instanceVariableNames: 'author'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

FOVote subclass: #FODownVote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FODownVote methodsFor: 'value' stamp: 'StephanEggermont 5/19/2011 11:27'!
increment
	^-1! !

FOVote subclass: #FOUpVote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOUpVote methodsFor: 'value' stamp: 'StephanEggermont 5/19/2011 11:27'!
increment
	^1! !

!FOVote class methodsFor: 'instance creation' stamp: 'StephanEggermont 5/19/2011 16:11'!
down: anAuthor
	^FODownVote on: anAuthor! !

!FOVote class methodsFor: 'instance creation' stamp: 'StephanEggermont 5/18/2011 17:22'!
on: anAuthor
	^self basicNew
		initialize: anAuthor;
		yourself! !

!FOVote class methodsFor: 'instance creation' stamp: 'StephanEggermont 5/19/2011 16:11'!
up: anAuthor
	^FOUpVote on: anAuthor! !

!FOVote methodsFor: 'value' stamp: 'StephanEggermont 5/19/2011 11:26'!
increment
	^self subclassResponsibility! !

!FOVote methodsFor: 'initialization' stamp: 'StephanEggermont 5/18/2011 17:23'!
initialize: anAuthor
	self initialize.
	author := anAuthor! !

QCComponent subclass: #FOAllQuestions
	instanceVariableNames: 'questionsReport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAllQuestions methodsFor: 'hooks' stamp: 'StephanEggermont 5/19/2011 14:59'!
children
	^Array with: self questionsReport! !

!FOAllQuestions methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 11:20'!
createQuestionsReport
	^((FOModel default magritteDescription select: [ :each | each accessor = #questions asAccessor ])
			asComponentOn: FOModel default)! !

!FOAllQuestions methodsFor: 'accessing' stamp: 'StephanEggermont 5/19/2011 14:57'!
questionsReport
	^questionsReport ifNil: [questionsReport := self createQuestionsReport]! !

!FOAllQuestions methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 14:53'!
renderContentOn: canvas
	canvas heading
		level: 2;
		with: 'All questions'.
	self renderQuestionsOn: canvas
	! !

!FOAllQuestions methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 10:51'!
renderQuestionsOn: canvas
	canvas render: self questionsReport! !

!FOAllQuestions methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 15:00'!
showDetails: aQuestion
	^ self announce: (FOGoViewQuestion on: aQuestion)! !

QCComponent subclass: #FOAskQuestionMagritte
	instanceVariableNames: 'editForm question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAskQuestionMagritte methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 13:29'!
buttons
	^OrderedCollection new
		add: ([ :d | self save ] -> 'Post your question');
		add: ([ :d | self cancel ] -> 'Cancel');
		yourself! !

!FOAskQuestionMagritte methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:29'!
cancel
	question := nil.
	editForm := nil.
	self announce: FOGoHome! !

!FOAskQuestionMagritte methodsFor: 'hooks' stamp: 'StephanEggermont 5/19/2011 22:47'!
children
	^Array with: self editForm! !

!FOAskQuestionMagritte methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 13:11'!
createEditForm
	^self question asComponent
		addForm: self buttons;
		addValidation;
		yourself! !

!FOAskQuestionMagritte methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 15:52'!
editForm
	editForm ifNil: [editForm := self createEditForm].
	^editForm! !

!FOAskQuestionMagritte methodsFor: 'accessing' stamp: 'DiegoLont 1/22/2014 13:11'!
question
	^question ifNil: [ question := FOQuestion new ]! !

!FOAskQuestionMagritte methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 16:10'!
renderContentOn: canvas
	canvas render: self editForm.! !

!FOAskQuestionMagritte methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:15'!
save
	FOModel default questions add: question.
	self cancel! !

!FOAskQuestionMagritte methodsFor: 'hooks' stamp: 'DiegoLont 1/22/2014 13:12'!
states
	^Array with: self question! !

QCComponent subclass: #FOAskQuestionSeaside
	instanceVariableNames: 'title contents tags author question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAskQuestionSeaside methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:31'!
cancel
	contents := nil.
	tags := nil.
	title := nil.
	self announce: FOGoHome
! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
contents
	^ contents! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
contents: anObject
	contents := anObject! !

!FOAskQuestionSeaside methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:31'!
postYourQuestion
	FOModel default newQuestion
		title: title;
		content: contents.
	self cancel		! !

!FOAskQuestionSeaside methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 13:31'!
renderContentOn: canvas
	canvas form:[
		canvas label: 'Title'.
		canvas textInput on: #title of: self.
		canvas break.
		canvas textArea on: #contents of: self.
		canvas break.
		canvas label: 'Tags'.
		canvas textInput on: #tags of: self.
		canvas break.
		canvas submitButton on: #postYourQuestion of: self.
		canvas space.
		canvas submitButton on: #cancel of: self ]! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
tags
	^ tags! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
tags: anObject
	tags := anObject! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
title
	^ title! !

!FOAskQuestionSeaside methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
title: anObject
	title := anObject! !

QCComponent subclass: #FOHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOHome methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 14:54'!
renderContentOn: canvas
	canvas heading
		level: 2;
		with: 'Top questions'.
	canvas div 
		class: 'homepage';
		with: [ self renderQuestionsOn: canvas.]! !

!FOHome methodsFor: 'rendering' stamp: 'StephanEggermont 4/29/2011 15:05'!
renderQuestion: aQuestion on: canvas
	(canvas div)
		class: 'question';
		with: [ 
			self renderVotesOf: aQuestion on: canvas.
			self renderSummaryOf: aQuestion on: canvas] ! !

!FOHome methodsFor: 'rendering' stamp: 'DiegoLont 6/29/2011 16:03'!
renderQuestionsOn: canvas
	(FOModel default questions sort: [:a :b | a voteValue > b voteValue ])do: [:each|
		self renderQuestion: each on: canvas]! !

!FOHome methodsFor: 'rendering' stamp: 'StephanEggermont 5/20/2011 16:19'!
renderSummaryOf: aQuestion on: canvas
	canvas div
		class: 'summary';
		with: [ 
			canvas div 
				class: 'title';
				with: [
			(canvas anchor)
					callback: [ self viewQuestion: aQuestion ];
					with: aQuestion title].
			canvas div
				class: 'contents';
				with: aQuestion content.
			canvas div 
				class: 'author';
				with: aQuestion authorName]
 ! !

!FOHome methodsFor: 'rendering' stamp: 'StephanEggermont 5/20/2011 23:42'!
renderVotesOf: aQuestion on: canvas
	|nr|
	nr := aQuestion voteSize.
	canvas div
		class: 'votes';
		with: [ 
			canvas div
				class: 'count';
				with: nr.
			nr = 1 ifTrue: [
				canvas div: 'vote'] 
			ifFalse: [			
				canvas div: 'votes' ]]! !

!FOHome methodsFor: 'actions' stamp: 'StephanEggermont 4/28/2011 22:48'!
viewQuestion: aQuestion
	^ self announce: (FOGoViewQuestion on: aQuestion)! !

QCComponent subclass: #FOViewQuestion
	instanceVariableNames: 'question editForm answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOViewQuestion methodsFor: 'accessing' stamp: 'WillemvandenEnde 10/3/2011 14:22'!
answerEditForm
	editForm ifNil: [editForm := self createAnswerEditForm].
	^editForm! !

!FOViewQuestion methodsFor: 'accessing' stamp: 'DiegoLont 1/22/2014 13:29'!
buttons
	^OrderedCollection new
		add: ([ :d | self save ] -> 'Post your question');
		add: ([ :d | self cancel ] -> 'Cancel');
		yourself! !

!FOViewQuestion methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:18'!
cancel
	answer := nil.
	editForm := nil.
	self answer: nil! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'DiegoLont 1/22/2014 13:24'!
createAnswerEditForm
	^self postedAnswer asComponent
		addForm: self buttons;
		addValidation;
		yourself! !

!FOViewQuestion methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 22:19'!
downvote 
	question voteDown: self  user ! !

!FOViewQuestion methodsFor: 'accessing' stamp: 'DiegoLont 1/22/2014 13:15'!
postedAnswer
	^answer ifNil: [ answer := FOAnswer new ]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:20'!
renderAnswer: anAnswer on: canvas
	(canvas div)
		class: 'view-answer';
		with: [ 
			self renderAnswer: anAnswer votesOn: canvas.
			self renderAnswerSummaryOf: anAnswer on: canvas.] ! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:04'!
renderAnswer: anAnswer votesOn: canvas
	canvas div
		class: 'votes';
		with: [ 
					canvas anchor
						callback: [ anAnswer upvote ];
						with: [ canvas html: '&#x25b2;' ].
					canvas break.
					canvas
						text: anAnswer voteValue;
						break.
					canvas anchor
						callback: [ anAnswer downvote ];
						with: [ canvas html: '&#x25bc;' ] ]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:08'!
renderAnswerSummaryOf: anAnswer on: canvas
	canvas div
		class: 'answer-summary';
		with: [ 
					canvas
						text: anAnswer content;
						break;
						text: anAnswer authorName ]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 14:46'!
renderAnswersOn: canvas
	question hasAnswers ifFalse: [^self].
	(canvas div)
		class: 'view-answers';
		with: [ 
			canvas heading 
				level: 1;
				with: question answerSizeString..
			question answers do: [:answer|
				self renderAnswer: answer on: canvas.
				]]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'WillemvandenEnde 10/3/2011 15:24'!
renderContentOn: canvas
	canvas div
		class: 'view-question';
		with: [ 
					canvas heading: question title.
					self renderVotesOn: canvas.
					canvas
						text: question content;
						break;
						text: question tagString;
						break;
						text: question authorName.
					self renderAnswersOn: canvas.
					canvas render: self answerEditForm ]! !

!FOViewQuestion methodsFor: 'rendering' stamp: 'StephanEggermont 5/20/2011 23:41'!
renderVotesOn: canvas
	canvas div
		class: 'votes';
		with: [
	canvas anchor 
		callback: [self upvote];
		with: [canvas html: '&#x25b2;'].
	canvas break.
	canvas
		text: question voteValue;
		break.
	canvas anchor 
		callback: [self downvote];
		with: [canvas html: '&#x25bc;']]
	! !

!FOViewQuestion methodsFor: 'actions' stamp: 'DiegoLont 1/22/2014 13:17'!
save
	question answers add: answer.
	self cancel! !

!FOViewQuestion methodsFor: 'initialization' stamp: 'StephanEggermont 4/28/2011 22:36'!
subject: aQuestion
	question  := aQuestion! !

!FOViewQuestion methodsFor: 'actions' stamp: 'StephanEggermont 5/19/2011 22:19'!
upvote
	question voteUp: self  user! !
FOAgileOverflow initialize!
